Index: trunk/include/VBox/HostServices/GuestControlSvc.h
===================================================================
--- trunk/include/VBox/HostServices/GuestControlSvc.h	(revision 98709)
+++ trunk/include/VBox/HostServices/GuestControlSvc.h	(revision 98792)
@@ -1608,151 +1608,4 @@
 } HGCMReplyFsNotify;
 #pragma pack ()
-
-
-/******************************************************************************
-* Callback data structures.                                                   *
-******************************************************************************/
-
-/**
- * The guest control callback data header. Must come first
- * on each callback structure defined below this struct.
- */
-typedef struct CALLBACKDATA_HEADER
-{
-    /** Context ID to identify callback data. This is
-     *  and *must* be the very first parameter in this
-     *  structure to still be backwards compatible. */
-    uint32_t uContextID;
-} CALLBACKDATA_HEADER, *PCALLBACKDATA_HEADER;
-
-/*
- * These structures make up the actual low level HGCM callback data sent from
- * the guest back to the host.
- */
-
-typedef struct CALLBACKDATA_CLIENT_DISCONNECTED
-{
-    /** Callback data header. */
-    CALLBACKDATA_HEADER hdr;
-} CALLBACKDATA_CLIENT_DISCONNECTED, *PCALLBACKDATA_CLIENT_DISCONNECTED;
-
-typedef struct CALLBACKDATA_MSG_REPLY
-{
-    /** Callback data header. */
-    CALLBACKDATA_HEADER hdr;
-    /** Notification type. */
-    uint32_t uType;
-    /** Notification result. Note: int vs. uint32! */
-    uint32_t rc;
-    /** Pointer to optional payload. */
-    void *pvPayload;
-    /** Payload size (in bytes). */
-    uint32_t cbPayload;
-} CALLBACKDATA_MSG_REPLY, *PCALLBACKDATA_MSG_REPLY;
-
-typedef struct CALLBACKDATA_SESSION_NOTIFY
-{
-    /** Callback data header. */
-    CALLBACKDATA_HEADER hdr;
-    /** Notification type. */
-    uint32_t uType;
-    /** Notification result. Note: int vs. uint32! */
-    uint32_t uResult;
-} CALLBACKDATA_SESSION_NOTIFY, *PCALLBACKDATA_SESSION_NOTIFY;
-
-typedef struct CALLBACKDATA_PROC_STATUS
-{
-    /** Callback data header. */
-    CALLBACKDATA_HEADER hdr;
-    /** The process ID (PID). */
-    uint32_t uPID;
-    /** The process status. */
-    uint32_t uStatus;
-    /** Optional flags, varies, based on u32Status. */
-    uint32_t uFlags;
-    /** Optional data buffer (not used atm). */
-    void *pvData;
-    /** Size of optional data buffer (not used atm). */
-    uint32_t cbData;
-} CALLBACKDATA_PROC_STATUS, *PCALLBACKDATA_PROC_STATUS;
-
-typedef struct CALLBACKDATA_PROC_OUTPUT
-{
-    /** Callback data header. */
-    CALLBACKDATA_HEADER hdr;
-    /** The process ID (PID). */
-    uint32_t uPID;
-    /** The handle ID (stdout/stderr). */
-    uint32_t uHandle;
-    /** Optional flags (not used atm). */
-    uint32_t uFlags;
-    /** Optional data buffer. */
-    void *pvData;
-    /** Size (in bytes) of optional data buffer. */
-    uint32_t cbData;
-} CALLBACKDATA_PROC_OUTPUT, *PCALLBACKDATA_PROC_OUTPUT;
-
-typedef struct CALLBACKDATA_PROC_INPUT
-{
-    /** Callback data header. */
-    CALLBACKDATA_HEADER hdr;
-    /** The process ID (PID). */
-    uint32_t uPID;
-    /** Current input status. */
-    uint32_t uStatus;
-    /** Optional flags. */
-    uint32_t uFlags;
-    /** Size (in bytes) of processed input data. */
-    uint32_t uProcessed;
-} CALLBACKDATA_PROC_INPUT, *PCALLBACKDATA_PROC_INPUT;
-
-/**
- * General guest file notification callback.
- */
-typedef struct CALLBACKDATA_FILE_NOTIFY
-{
-    /** Callback data header. */
-    CALLBACKDATA_HEADER hdr;
-    /** Notification type. */
-    uint32_t uType;
-    /** IPRT result of overall operation. */
-    uint32_t rc;
-    union
-    {
-        struct
-        {
-            /** Guest file handle. */
-            uint32_t uHandle;
-        } open;
-        /** Note: Close does not have any additional data (yet). */
-        struct
-        {
-            /** How much data (in bytes) have been read. */
-            uint32_t cbData;
-            /** Actual data read (if any). */
-            void *pvData;
-        } read;
-        struct
-        {
-            /** How much data (in bytes) have been successfully written. */
-            uint32_t cbWritten;
-        } write;
-        struct
-        {
-            /** New file offset after successful seek. */
-            uint64_t uOffActual;
-        } seek;
-        struct
-        {
-            /** New file offset after successful tell. */
-            uint64_t uOffActual;
-        } tell;
-        struct
-        {
-            /** The new file siz.e */
-            uint64_t cbSize;
-        } SetSize;
-    } u;
-} CALLBACKDATA_FILE_NOTIFY, *PCALLBACKDATA_FILE_NOTIFY;
 } /* namespace guestControl */
 