Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 98801)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.cpp	(revision 98802)
@@ -69,6 +69,5 @@
 *   UIRuntimeInfoWidget definition.                                                                                     *
 *********************************************************************************************************************************/
-/** A QTablWidget extention to show some runtime attributes. Some of these are updated in response to IConsole events. Uptime field
-  * is updated thru a QTimer. */
+/** A QTablWidget extention to show some runtime attributes */
 class UIRuntimeInfoWidget : public QIWithRetranslateUI<QTableWidget>
 {
@@ -78,5 +77,5 @@
 public:
 
-    UIRuntimeInfoWidget(QWidget *pParent, const CMachine &machine, const CConsole &console);
+    UIRuntimeInfoWidget(QWidget *pParent, const CMachine &machine);
     void updateScreenInfo(int iScreenId = -1);
     void updateGAsVersion();
@@ -112,5 +111,4 @@
 
     CMachine m_machine;
-    CConsole m_console;
 
     /** @name Cached translated strings.
@@ -151,8 +149,7 @@
 *********************************************************************************************************************************/
 
-UIRuntimeInfoWidget::UIRuntimeInfoWidget(QWidget *pParent, const CMachine &machine, const CConsole &console)
+UIRuntimeInfoWidget::UIRuntimeInfoWidget(QWidget *pParent, const CMachine &machine)
     : QIWithRetranslateUI<QTableWidget>(pParent)
     , m_machine(machine)
-    , m_console(console)
     , m_iMinimumWidth(0)
     , m_pTimer(0)
@@ -507,8 +504,7 @@
 *********************************************************************************************************************************/
 
-UIInformationRuntime::UIInformationRuntime(QWidget *pParent, const CMachine &machine, const CConsole &console, const UIMachine *pMachine)
+UIInformationRuntime::UIInformationRuntime(QWidget *pParent, const CMachine &machine, const UIMachine *pMachine)
     : QIWithRetranslateUI<QWidget>(pParent)
     , m_machine(machine)
-    , m_console(console)
     , m_pMainLayout(0)
     , m_pRuntimeInfoWidget(0)
@@ -538,5 +534,5 @@
     m_pMainLayout->setSpacing(0);
 
-    m_pRuntimeInfoWidget = new UIRuntimeInfoWidget(0, m_machine, m_console);
+    m_pRuntimeInfoWidget = new UIRuntimeInfoWidget(0, m_machine);
     AssertReturnVoid(m_pRuntimeInfoWidget);
     connect(m_pRuntimeInfoWidget, &UIRuntimeInfoWidget::customContextMenuRequested,
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.h	(revision 98801)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIInformationRuntime.h	(revision 98802)
@@ -37,5 +37,4 @@
 /* COM includes: */
 #include "COMEnums.h"
-#include "CConsole.h"
 #include "CMachine.h"
 
@@ -58,7 +57,6 @@
 
     /** Constructs information-tab passing @a pParent to the QWidget base-class constructor.
-      * @param machine is machine reference.
-      * @param console is machine console reference. */
-    UIInformationRuntime(QWidget *pParent, const CMachine &machine, const CConsole &console, const UIMachine *pMachine);
+      * @param machine is machine reference. */
+    UIInformationRuntime(QWidget *pParent, const CMachine &machine, const UIMachine *pMachine);
 
 protected:
@@ -84,5 +82,4 @@
 
     CMachine m_machine;
-    CConsole m_console;
 
     /** Holds the instance of layout we create. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 98801)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/information/UIVMInformationDialog.cpp	(revision 98802)
@@ -218,5 +218,5 @@
         /* Create Runtime Information tab: */
         UIInformationRuntime *pInformationRuntimeWidget =
-            new UIInformationRuntime(this, m_pMachine->uisession()->machine(), m_pMachine->uisession()->console(), m_pMachine);
+            new UIInformationRuntime(this, m_pMachine->uisession()->machine(), m_pMachine);
         if (pInformationRuntimeWidget)
         {