Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 98885)
@@ -189,7 +189,4 @@
     , m_fDataCommitted(false)
 #endif
-#ifdef VBOX_WS_MAC
-    , m_enmMacOSVersion(MacOSXRelease_Old)
-#endif
 #ifdef VBOX_WS_X11
     , m_enmWindowManagerType(X11WMType_Unknown)
@@ -244,9 +241,4 @@
             this, &UICommon::sltHandleCommitDataRequest);
 #endif /* VBOX_GUI_WITH_CUSTOMIZATIONS1 */
-
-#ifdef VBOX_WS_MAC
-    /* Determine OS release early: */
-    m_enmMacOSVersion = determineOsRelease();
-#endif /* VBOX_WS_MAC */
 
     /* Create converter: */
@@ -945,32 +937,4 @@
     return settings.value(QString("%1").arg(strKey)).toString();
 }
-
-#ifdef VBOX_WS_MAC
-/* static */
-MacOSXRelease UICommon::determineOsRelease()
-{
-    /* Prepare 'utsname' struct: */
-    utsname info;
-    if (uname(&info) != -1)
-    {
-        /* Compose map of known releases: */
-        QMap<int, MacOSXRelease> release;
-        release[10] = MacOSXRelease_SnowLeopard;
-        release[11] = MacOSXRelease_Lion;
-        release[12] = MacOSXRelease_MountainLion;
-        release[13] = MacOSXRelease_Mavericks;
-        release[14] = MacOSXRelease_Yosemite;
-        release[15] = MacOSXRelease_ElCapitan;
-
-        /* Cut the major release index of the string we have, s.a. 'man uname': */
-        const int iRelease = QString(info.release).section('.', 0, 0).toInt();
-
-        /* Return release if determined, return 'New' if version more recent than latest, return 'Old' otherwise: */
-        return release.value(iRelease, iRelease > release.keys().last() ? MacOSXRelease_New : MacOSXRelease_Old);
-    }
-    /* Return 'Old' by default: */
-    return MacOSXRelease_Old;
-}
-#endif /* VBOX_WS_MAC */
 
 #ifdef VBOX_WS_WIN
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 98885)
@@ -205,11 +205,4 @@
     /** @name Host OS stuff.
      * @{ */
-#ifdef VBOX_WS_MAC
-        /** Mac OS X: Returns #MacOSXRelease determined by <i>uname</i> call. */
-        static MacOSXRelease determineOsRelease();
-        /** Mac OS X: Returns #MacOSXRelease determined during UICommon prepare routine. */
-        MacOSXRelease osRelease() const { return m_enmMacOSVersion; }
-#endif
-
 #ifdef VBOX_WS_WIN
         /** Loads the color theme. */
@@ -649,9 +642,4 @@
     /** @name Host OS stuff.
      * @{ */
-#ifdef VBOX_WS_MAC
-        /** Mac OS X: Holds the #MacOSXRelease determined using <i>uname</i> call. */
-        MacOSXRelease  m_enmMacOSVersion;
-#endif
-
 #ifdef VBOX_WS_X11
         /** X11: Holds the #X11WMType of the Window Manager we are running under. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIDefs.h	(revision 98885)
@@ -98,20 +98,4 @@
 
 
-#ifdef VBOX_WS_MAC
-/** Known macOS releases. */
-enum MacOSXRelease
-{
-    MacOSXRelease_Old,
-    MacOSXRelease_SnowLeopard,
-    MacOSXRelease_Lion,
-    MacOSXRelease_MountainLion,
-    MacOSXRelease_Mavericks,
-    MacOSXRelease_Yosemite,
-    MacOSXRelease_ElCapitan,
-    MacOSXRelease_New,
-};
-#endif /* VBOX_WS_MAC */
-
-
 /** Size suffixes. */
 enum SizeSuffix
Index: /trunk/src/VBox/Frontends/VirtualBox/src/main.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/main.cpp	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/main.cpp	(revision 98885)
@@ -426,13 +426,4 @@
 
 #ifdef VBOX_WS_MAC
-        /* Apply font fixes (before QApplication get created and instantiated font-hints): */
-        switch (UICommon::determineOsRelease())
-        {
-            case MacOSXRelease_Mavericks: QFont::insertSubstitution(".Lucida Grande UI", "Lucida Grande"); break;
-            case MacOSXRelease_Yosemite:  QFont::insertSubstitution(".Helvetica Neue DeskInterface", "Helvetica Neue"); break;
-            case MacOSXRelease_ElCapitan: QFont::insertSubstitution(".SF NS Text", "Helvetica Neue"); break;
-            default: break;
-        }
-
         /* Instantiate own NSApplication before QApplication do it for us: */
         UICocoaApplication::instance();
@@ -451,5 +442,5 @@
             QCoreApplication::addLibraryPath(QString::fromUtf8(szExecDir));
         }
-# endif
+# endif /* VBOX_RUNTIME_UI */
 #endif /* VBOX_WS_MAC */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 98885)
@@ -110,6 +110,5 @@
     Q_UNUSED(uScreenId);
 #ifdef VBOX_WS_MAC
-    return uiCommon().osRelease() <= MacOSXRelease_Lion ? Qt::FramelessWindowHint :
-           uScreenId == 0 || screensHaveSeparateSpaces() ? Qt::Window : Qt::FramelessWindowHint;
+    return uScreenId == 0 || screensHaveSeparateSpaces() ? Qt::Window : Qt::FramelessWindowHint;
 #else /* !VBOX_WS_MAC */
     return Qt::FramelessWindowHint;
@@ -125,13 +124,6 @@
 
 #ifdef VBOX_WS_MAC
-    /* For Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-    {
-        /* Make sure all machine-window(s) have proper geometry: */
-        foreach (UIMachineWindow *pMachineWindow, machineWindows())
-            pMachineWindow->showInNecessaryMode();
-    }
-    /* For ML and next revalidate native fullscreen: */
-    else revalidateNativeFullScreen();
+    /* Revalidate native fullscreen: */
+    revalidateNativeFullScreen();
 #else /* !VBOX_WS_MAC */
     /* Make sure all machine-window(s) have proper geometry: */
@@ -144,7 +136,4 @@
 void UIMachineLogicFullscreen::sltHandleNativeFullscreenWillEnter()
 {
-    /* Make sure this method is only used for ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
@@ -157,7 +146,4 @@
 void UIMachineLogicFullscreen::sltHandleNativeFullscreenDidEnter()
 {
-    /* Make sure this method is only used for ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
@@ -179,7 +165,4 @@
 void UIMachineLogicFullscreen::sltHandleNativeFullscreenWillExit()
 {
-    /* Make sure this method is only used for ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
@@ -192,7 +175,4 @@
 void UIMachineLogicFullscreen::sltHandleNativeFullscreenDidExit()
 {
-    /* Make sure this method is only used for ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
@@ -257,7 +237,4 @@
 void UIMachineLogicFullscreen::sltHandleNativeFullscreenFailToEnter()
 {
-    /* Make sure this method is only used for ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Get sender machine-window: */
     UIMachineWindow *pMachineWindow = qobject_cast<UIMachineWindow*>(sender());
@@ -296,45 +273,24 @@
 void UIMachineLogicFullscreen::sltChangeVisualStateToNormal()
 {
-    /* Base-class handling for Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-        UIMachineLogic::sltChangeVisualStateToNormal();
-    /* Special handling for ML and next: */
-    else
-    {
-        /* Request 'normal' (window) visual-state: */
-        uimachine()->setRequestedVisualState(UIVisualStateType_Normal);
-        /* Ask window(s) to exit 'fullscreen' mode: */
-        emit sigNotifyAboutNativeFullscreenShouldBeExited();
-    }
+    /* Request 'normal' (window) visual-state: */
+    uimachine()->setRequestedVisualState(UIVisualStateType_Normal);
+    /* Ask window(s) to exit 'fullscreen' mode: */
+    emit sigNotifyAboutNativeFullscreenShouldBeExited();
 }
 
 void UIMachineLogicFullscreen::sltChangeVisualStateToSeamless()
 {
-    /* Base-class handling for Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-        UIMachineLogic::sltChangeVisualStateToSeamless();
-    /* Special handling for ML and next: */
-    else
-    {
-        /* Request 'seamless' visual-state: */
-        uimachine()->setRequestedVisualState(UIVisualStateType_Seamless);
-        /* Ask window(s) to exit 'fullscreen' mode: */
-        emit sigNotifyAboutNativeFullscreenShouldBeExited();
-    }
+    /* Request 'seamless' visual-state: */
+    uimachine()->setRequestedVisualState(UIVisualStateType_Seamless);
+    /* Ask window(s) to exit 'fullscreen' mode: */
+    emit sigNotifyAboutNativeFullscreenShouldBeExited();
 }
 
 void UIMachineLogicFullscreen::sltChangeVisualStateToScale()
 {
-    /* Base-class handling for Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-        UIMachineLogic::sltChangeVisualStateToScale();
-    /* Special handling for ML and next: */
-    else
-    {
-        /* Request 'scale' visual-state: */
-        uimachine()->setRequestedVisualState(UIVisualStateType_Scale);
-        /* Ask window(s) to exit 'fullscreen' mode: */
-        emit sigNotifyAboutNativeFullscreenShouldBeExited();
-    }
+    /* Request 'scale' visual-state: */
+    uimachine()->setRequestedVisualState(UIVisualStateType_Scale);
+    /* Ask window(s) to exit 'fullscreen' mode: */
+    emit sigNotifyAboutNativeFullscreenShouldBeExited();
 }
 
@@ -404,13 +360,6 @@
 
 #ifdef VBOX_WS_MAC
-    /* For Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-    {
-        /* Make sure all machine-window(s) have proper geometry: */
-        foreach (UIMachineWindow *pMachineWindow, machineWindows())
-            pMachineWindow->showInNecessaryMode();
-    }
-    /* Revalidate native fullscreen for ML and next: */
-    else revalidateNativeFullScreen();
+    /* Revalidate native fullscreen: */
+    revalidateNativeFullScreen();
 #else /* !VBOX_WS_MAC */
     /* Make sure all machine-window(s) have proper geometry: */
@@ -428,9 +377,7 @@
 
 #ifdef VBOX_WS_MAC
-    /* Call to base-class for Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-        UIMachineLogic::sltGuestMonitorChange(changeType, uScreenId, screenGeo);
-    /* Revalidate native fullscreen for ML and next: */
-    else revalidateNativeFullScreen();
+    /* Revalidate native fullscreen: */
+    RT_NOREF(changeType, uScreenId, screenGeo);
+    revalidateNativeFullScreen();
 #else /* !VBOX_WS_MAC */
     /* Call to base-class: */
@@ -447,9 +394,6 @@
 
 #ifdef VBOX_WS_MAC
-    /* Call to base-class for Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-        UIMachineLogic::sltHostScreenCountChange();
-    /* Revalidate native fullscreen for ML and next: */
-    else revalidateNativeFullScreen();
+    /* Revalidate native fullscreen: */
+    revalidateNativeFullScreen();
 #else /* !VBOX_WS_MAC */
     /* Call to base-class: */
@@ -522,13 +466,9 @@
 
 #ifdef VBOX_WS_MAC
-    /* For ML and next: */
-    if (uiCommon().osRelease() > MacOSXRelease_Lion)
-    {
-        /* Register to native notifications: */
-        UICocoaApplication::instance()->registerToNotificationOfWorkspace("NSWorkspaceDidActivateApplicationNotification", this,
-                                                                          UIMachineLogicFullscreen::nativeHandlerForApplicationActivation);
-        UICocoaApplication::instance()->registerToNotificationOfWorkspace("NSWorkspaceActiveSpaceDidChangeNotification", this,
-                                                                          UIMachineLogicFullscreen::nativeHandlerForActiveSpaceChange);
-    }
+    /* Register to native notifications: */
+    UICocoaApplication::instance()->registerToNotificationOfWorkspace("NSWorkspaceDidActivateApplicationNotification", this,
+                                                                      UIMachineLogicFullscreen::nativeHandlerForApplicationActivation);
+    UICocoaApplication::instance()->registerToNotificationOfWorkspace("NSWorkspaceActiveSpaceDidChangeNotification", this,
+                                                                      UIMachineLogicFullscreen::nativeHandlerForActiveSpaceChange);
 
     /* We have to make sure that we are getting the front most process.
@@ -553,38 +493,34 @@
 
 #ifdef VBOX_WS_MAC
-    /* For ML and next: */
-    if (uiCommon().osRelease() > MacOSXRelease_Lion)
-    {
-        /* Enable native fullscreen support: */
-        foreach (UIMachineWindow *pMachineWindow, machineWindows())
-        {
-            UIMachineWindowFullscreen *pMachineWindowFullscreen = qobject_cast<UIMachineWindowFullscreen*>(pMachineWindow);
-            if (!pMachineWindow)
-                continue;
-            /* Logic => window signals: */
-            connect(this, &UIMachineLogicFullscreen::sigNotifyAboutNativeFullscreenShouldBeEntered,
-                    pMachineWindowFullscreen, &UIMachineWindowFullscreen::sltEnterNativeFullscreen);
-            connect(this, &UIMachineLogicFullscreen::sigNotifyAboutNativeFullscreenShouldBeExited,
-                    pMachineWindowFullscreen, &UIMachineWindowFullscreen::sltExitNativeFullscreen);
-            /* Window => logic signals: */
-            connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenWillEnter,
-                    this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenWillEnter,
-                     Qt::QueuedConnection);
-            connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenDidEnter,
-                    this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenDidEnter,
-                    Qt::QueuedConnection);
-            connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenWillExit,
-                    this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenWillExit,
-                    Qt::QueuedConnection);
-            connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenDidExit,
-                    this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenDidExit,
-                    Qt::QueuedConnection);
-            connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenFailToEnter,
-                    this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenFailToEnter,
-                    Qt::QueuedConnection);
-        }
-        /* Revalidate native fullscreen: */
-        revalidateNativeFullScreen();
-    }
+    /* Enable native fullscreen support: */
+    foreach (UIMachineWindow *pMachineWindow, machineWindows())
+    {
+        UIMachineWindowFullscreen *pMachineWindowFullscreen = qobject_cast<UIMachineWindowFullscreen*>(pMachineWindow);
+        if (!pMachineWindow)
+            continue;
+        /* Logic => window signals: */
+        connect(this, &UIMachineLogicFullscreen::sigNotifyAboutNativeFullscreenShouldBeEntered,
+                pMachineWindowFullscreen, &UIMachineWindowFullscreen::sltEnterNativeFullscreen);
+        connect(this, &UIMachineLogicFullscreen::sigNotifyAboutNativeFullscreenShouldBeExited,
+                pMachineWindowFullscreen, &UIMachineWindowFullscreen::sltExitNativeFullscreen);
+        /* Window => logic signals: */
+        connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenWillEnter,
+                this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenWillEnter,
+                 Qt::QueuedConnection);
+        connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenDidEnter,
+                this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenDidEnter,
+                Qt::QueuedConnection);
+        connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenWillExit,
+                this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenWillExit,
+                Qt::QueuedConnection);
+        connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenDidExit,
+                this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenDidExit,
+                Qt::QueuedConnection);
+        connect(pMachineWindowFullscreen, &UIMachineWindowFullscreen::sigNotifyAboutNativeFullscreenFailToEnter,
+                this, &UIMachineLogicFullscreen::sltHandleNativeFullscreenFailToEnter,
+                Qt::QueuedConnection);
+    }
+    /* Revalidate native fullscreen: */
+    revalidateNativeFullScreen();
 #endif /* VBOX_WS_MAC */
 
@@ -637,11 +573,7 @@
 
 #ifdef VBOX_WS_MAC
-    /* For ML and next: */
-    if (uiCommon().osRelease() > MacOSXRelease_Lion)
-    {
-        /* Unregister from native notifications: */
-        UICocoaApplication::instance()->unregisterFromNotificationOfWorkspace("NSWorkspaceDidActivateApplicationNotification", this);
-        UICocoaApplication::instance()->unregisterFromNotificationOfWorkspace("NSWorkspaceActiveSpaceDidChangeNotification", this);
-    }
+    /* Unregister from native notifications: */
+    UICocoaApplication::instance()->unregisterFromNotificationOfWorkspace("NSWorkspaceDidActivateApplicationNotification", this);
+    UICocoaApplication::instance()->unregisterFromNotificationOfWorkspace("NSWorkspaceActiveSpaceDidChangeNotification", this);
 #endif/* VBOX_WS_MAC */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 98885)
@@ -74,7 +74,4 @@
 void UIMachineWindowFullscreen::handleNativeNotification(const QString &strNativeNotificationName)
 {
-    /* Make sure this method is only used for ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Log all arrived notifications: */
     LogRel(("UIMachineWindowFullscreen::handleNativeNotification: Notification '%s' received.\n",
@@ -170,7 +167,4 @@
 void UIMachineWindowFullscreen::sltEnterNativeFullscreen(UIMachineWindow *pMachineWindow)
 {
-    /* Make sure this slot is called only under ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Make sure it is NULL or 'this' window passed: */
     if (pMachineWindow && pMachineWindow != this)
@@ -197,7 +191,4 @@
 void UIMachineWindowFullscreen::sltExitNativeFullscreen(UIMachineWindow *pMachineWindow)
 {
-    /* Make sure this slot is called only under ML and next: */
-    AssertReturnVoid(uiCommon().osRelease() > MacOSXRelease_Lion);
-
     /* Make sure it is NULL or 'this' window passed: */
     if (pMachineWindow && pMachineWindow != this)
@@ -252,28 +243,24 @@
 
 #ifdef VBOX_WS_MAC
-    /* Native fullscreen stuff on ML and next: */
-    if (uiCommon().osRelease() > MacOSXRelease_Lion)
-    {
-        /* Make sure this window has fullscreen logic: */
-        UIMachineLogicFullscreen *pFullscreenLogic = qobject_cast<UIMachineLogicFullscreen*>(machineLogic());
-        AssertPtrReturnVoid(pFullscreenLogic);
-        /* Enable fullscreen support for every screen which requires it: */
-        if (pFullscreenLogic->screensHaveSeparateSpaces() || m_uScreenId == 0)
-            darwinEnableFullscreenSupport(this);
-        /* Enable transience support for other screens: */
-        else
-            darwinEnableTransienceSupport(this);
-        /* Register to native fullscreen notifications: */
-        UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowWillEnterFullScreenNotification", this,
-                                                                       UIMachineWindow::handleNativeNotification);
-        UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowDidEnterFullScreenNotification", this,
-                                                                       UIMachineWindow::handleNativeNotification);
-        UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowWillExitFullScreenNotification", this,
-                                                                       UIMachineWindow::handleNativeNotification);
-        UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowDidExitFullScreenNotification", this,
-                                                                       UIMachineWindow::handleNativeNotification);
-        UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowDidFailToEnterFullScreenNotification", this,
-                                                                       UIMachineWindow::handleNativeNotification);
-}
+    /* Make sure this window has fullscreen logic: */
+    UIMachineLogicFullscreen *pFullscreenLogic = qobject_cast<UIMachineLogicFullscreen*>(machineLogic());
+    AssertPtrReturnVoid(pFullscreenLogic);
+    /* Enable fullscreen support for every screen which requires it: */
+    if (pFullscreenLogic->screensHaveSeparateSpaces() || m_uScreenId == 0)
+        darwinEnableFullscreenSupport(this);
+    /* Enable transience support for other screens: */
+    else
+        darwinEnableTransienceSupport(this);
+    /* Register to native fullscreen notifications: */
+    UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowWillEnterFullScreenNotification", this,
+                                                                   UIMachineWindow::handleNativeNotification);
+    UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowDidEnterFullScreenNotification", this,
+                                                                   UIMachineWindow::handleNativeNotification);
+    UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowWillExitFullScreenNotification", this,
+                                                                   UIMachineWindow::handleNativeNotification);
+    UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowDidExitFullScreenNotification", this,
+                                                                   UIMachineWindow::handleNativeNotification);
+    UICocoaApplication::instance()->registerToNotificationOfWindow("NSWindowDidFailToEnterFullScreenNotification", this,
+                                                                   UIMachineWindow::handleNativeNotification);
 #endif /* VBOX_WS_MAC */
 }
@@ -322,14 +309,10 @@
 {
 #ifdef VBOX_WS_MAC
-    /* Native fullscreen stuff on ML and next: */
-    if (uiCommon().osRelease() > MacOSXRelease_Lion)
-    {
-        /* Unregister from native fullscreen notifications: */
-        UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowWillEnterFullScreenNotification", this);
-        UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowDidEnterFullScreenNotification", this);
-        UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowWillExitFullScreenNotification", this);
-        UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowDidExitFullScreenNotification", this);
-        UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowDidFailToEnterFullScreenNotification", this);
-    }
+    /* Unregister from native fullscreen notifications: */
+    UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowWillEnterFullScreenNotification", this);
+    UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowDidEnterFullScreenNotification", this);
+    UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowWillExitFullScreenNotification", this);
+    UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowDidExitFullScreenNotification", this);
+    UICocoaApplication::instance()->unregisterFromNotificationOfWindow("NSWindowDidFailToEnterFullScreenNotification", this);
 #endif /* VBOX_WS_MAC */
 
@@ -366,12 +349,9 @@
     move(workingArea.topLeft());
 
-    /* Resize window to the appropriate size on Lion and previous: */
-    if (uiCommon().osRelease() <= MacOSXRelease_Lion)
-        resize(workingArea.size());
-    /* Resize window to the appropriate size on ML and next if it's screen has no own user-space: */
-    else if (!pFullscreenLogic->screensHaveSeparateSpaces() && m_uScreenId != 0)
+    /* Resize window to the appropriate size if it's screen has no own user-space: */
+    if (!pFullscreenLogic->screensHaveSeparateSpaces() && m_uScreenId != 0)
         resize(workingArea.size());
     /* Resize the window if we are already in the full screen mode. This covers cases like host-resolution changes while in full screen mode: */
-    else if(darwinIsInFullscreenMode(this))
+    else if (darwinIsInFullscreenMode(this))
         resize(workingArea.size());
     else
@@ -443,9 +423,6 @@
         placeOnScreen();
 
-        /* Simple show() for ML and next, showFullScreen() otherwise: */
-        if (uiCommon().osRelease() > MacOSXRelease_Lion)
-            show();
-        else
-            showFullScreen();
+        /* Just show instead of showFullScreen: */
+        show();
 
         /* Adjust machine-view size if necessary: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 98885)
@@ -363,14 +363,10 @@
     }
 
-    /* For 'Yosemite' and above: */
-    if (uiCommon().osRelease() >= MacOSXRelease_Yosemite)
-    {
-        /* Enable fullscreen support for every screen which requires it: */
-        if (darwinScreensHaveSeparateSpaces() || m_uScreenId == 0)
-            darwinEnableFullscreenSupport(this);
-        /* Register 'Zoom' button to use our full-screen: */
-        UICocoaApplication::instance()->registerCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom,
-                                                                                UIMachineWindow::handleStandardWindowButtonCallback);
-    }
+    /* Enable fullscreen support for every screen which requires it: */
+    if (darwinScreensHaveSeparateSpaces() || m_uScreenId == 0)
+        darwinEnableFullscreenSupport(this);
+    /* Register 'Zoom' button to use our full-screen: */
+    UICocoaApplication::instance()->registerCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom,
+                                                                            UIMachineWindow::handleStandardWindowButtonCallback);
 #endif /* VBOX_WS_MAC */
 }
@@ -443,7 +439,6 @@
 {
 #ifdef VBOX_WS_MAC
-    /* Unregister 'Zoom' button from using our full-screen since Yosemite: */
-    if (uiCommon().osRelease() >= MacOSXRelease_Yosemite)
-        UICocoaApplication::instance()->unregisterCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom);
+    /* Unregister 'Zoom' button from using our full-screen: */
+    UICocoaApplication::instance()->unregisterCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom);
 #endif /* VBOX_WS_MAC */
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 98884)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 98885)
@@ -88,14 +88,10 @@
     }
 
-    /* For 'Yosemite' and above: */
-    if (uiCommon().osRelease() >= MacOSXRelease_Yosemite)
-    {
-        /* Enable fullscreen support for every screen which requires it: */
-        if (darwinScreensHaveSeparateSpaces() || m_uScreenId == 0)
-            darwinEnableFullscreenSupport(this);
-        /* Register 'Zoom' button to use our full-screen: */
-        UICocoaApplication::instance()->registerCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom,
-                                                                                UIMachineWindow::handleStandardWindowButtonCallback);
-    }
+    /* Enable fullscreen support for every screen which requires it: */
+    if (darwinScreensHaveSeparateSpaces() || m_uScreenId == 0)
+        darwinEnableFullscreenSupport(this);
+    /* Register 'Zoom' button to use our full-screen: */
+    UICocoaApplication::instance()->registerCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom,
+                                                                            UIMachineWindow::handleStandardWindowButtonCallback);
 }
 #endif /* VBOX_WS_MAC */
@@ -151,7 +147,6 @@
 void UIMachineWindowScale::cleanupVisualState()
 {
-    /* Unregister 'Zoom' button from using our full-screen since Yosemite: */
-    if (uiCommon().osRelease() >= MacOSXRelease_Yosemite)
-        UICocoaApplication::instance()->unregisterCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom);
+    /* Unregister 'Zoom' button from using our full-screen: */
+    UICocoaApplication::instance()->unregisterCallbackForStandardWindowButton(this, StandardWindowButtonType_Zoom);
 }
 #endif /* VBOX_WS_MAC */