Index: trunk/doc/manual/.scm-settings
===================================================================
--- trunk/doc/manual/.scm-settings	(revision 99014)
+++ trunk/doc/manual/.scm-settings	(revision 99016)
@@ -29,4 +29,5 @@
 /string.xsl:             --external-copyright --no-convert-tabs
 /titlepage-htmlhelp.xml: --external-copyright --no-convert-tabs
+*.dita: --treat-as xml --no-update-license --no-update-copyright-year --no-strip-trailing-blanks
 
 --filter-out-dirs  /texfiles/.
Index: trunk/doc/manual/Config.kmk
===================================================================
--- trunk/doc/manual/Config.kmk	(revision 99014)
+++ trunk/doc/manual/Config.kmk	(revision 99016)
@@ -387,6 +387,6 @@
   		$$(VBOX_PATH_MANUAL_SRC)/dita-refentry-link-replacement-xsl-gen.xsl \
   		$$(VBOX_PATH_MANUAL_SRC)/ditamap-to-single-xml.xsl \
-               $$(VBOX_PATH_MANUAL_SRC)/$(1)/dita/UserManual.ditamap \
-               $$(wildcard $$(VBOX_PATH_MANUAL_SRC)/$(1)/dita/topics/*.xml) \
+  		$$(VBOX_PATH_MANUAL_SRC)/$(1)/dita/UserManual.ditamap \
+  		$$(wildcard $$(VBOX_PATH_MANUAL_SRC)/$(1)/dita/topics/*.xml) \
   		$$(VBOX_MANUAL_XML_FILES_COMMON) \
   		$$(VBOX_XML_CATALOG) $$(VBOX_XML_CATALOG_DOCBOOK) $$(VBOX_XML_CATALOG_MANUAL) $$(VBOX_XML_ENTITIES) \
@@ -403,5 +403,5 @@
 	$$(QUIET)$$(call VBOX_XSLTPROC_WITH_CAT,,$$(VBOX_PATH_MANUAL_OUTBASE)/$(1)/$$(VBOX_XML_XREF_TO_TEXT).cat) \
 		--output "$$@.tmp.xml" "$$(VBOX_PATH_MANUAL_SRC)/ditamap-to-single-xml.xsl" $$(filter %.ditamap,$$^)
-#	$$(QUIET)$$(call VBOX_XSLTPROC_WITH_CAT,,$$(VBOX_PATH_MANUAL_OUTBASE)/$(1)/$$(VBOX_XML_XREF_TO_TEXT).cat) \
+  #	$$(QUIET)$$(call VBOX_XSLTPROC_WITH_CAT,,$$(VBOX_PATH_MANUAL_OUTBASE)/$(1)/$$(VBOX_XML_XREF_TO_TEXT).cat) \
 #		--path "$$(VBOX_PATH_MANUAL_SRC)/$(1)/dita/topics" \
 #		--path "$(VBOX_DITA_ORIGINAL_PATH)/dtd/bookmap/dtd" \
Index: trunk/doc/manual/en_US/dita/topics/network_performance.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/network_performance.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/network_performance.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/settings-disk-encryption.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/settings-disk-encryption.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/settings-disk-encryption.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/settings-system.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/settings-system.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/settings-system.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/settings-usb.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/settings-usb.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/settings-usb.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/sf_mount_auto.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/sf_mount_auto.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/sf_mount_auto.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/sf_mount_manual.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/sf_mount_manual.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/sf_mount_manual.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/shared-folders.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/shared-folders.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/shared-folders.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/sharedfolders.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/sharedfolders.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/sharedfolders.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/snapshots-contents.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/snapshots-contents.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/snapshots-contents.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/snapshots-take-restore-delete.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/snapshots-take-restore-delete.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/snapshots-take-restore-delete.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/snapshots.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/snapshots.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/snapshots.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/soft-keyb-custom.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/soft-keyb-custom.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/soft-keyb-custom.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/soft-keyb-using.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/soft-keyb-using.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/soft-keyb-using.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/soft-keyb.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/soft-keyb.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/soft-keyb.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/solaris-zones.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/solaris-zones.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/solaris-zones.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/specialcharacters.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/specialcharacters.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/specialcharacters.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/startingvboxonlinux.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/startingvboxonlinux.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/startingvboxonlinux.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/storage-bandwidth-limit.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/storage-bandwidth-limit.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/storage-bandwidth-limit.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/storage-cds.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/storage-cds.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/storage-cds.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/storage-iscsi.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/storage-iscsi.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/storage-iscsi.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/storage.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/storage.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/storage.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/unattended-guest-install-example.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/unattended-guest-install-example.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/unattended-guest-install-example.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/uninstall-solaris-host.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/uninstall-solaris-host.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/uninstall-solaris-host.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/usb-implementation-notes.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/usb-implementation-notes.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/usb-implementation-notes.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/usb-support.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/usb-support.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/usb-support.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/user-interface.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/user-interface.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/user-interface.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vboximg-mount-display.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboximg-mount-display.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vboximg-mount-display.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vboximg-mount-steps.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboximg-mount-steps.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vboximg-mount-steps.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vboximg-mount.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboximg-mount.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vboximg-mount.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vboxmanage-general.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboxmanage-general.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vboxmanage-general.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vboxmanage-intro.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboxmanage-intro.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vboxmanage-intro.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vboxmanage.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboxmanage.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vboxmanage.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vboxmanager-wizards.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vboxmanager-wizards.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vboxmanager-wizards.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vdidetails.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vdidetails.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vdidetails.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/virt-why-useful.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/virt-why-useful.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/virt-why-useful.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/virtintro.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/virtintro.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/virtintro.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/virtual-media-manager.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/virtual-media-manager.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/virtual-media-manager.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vm-activity-overview.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vm-activity-overview.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vm-activity-overview.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vm-activity-session-information.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vm-activity-session-information.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vm-activity-session-information.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/vm-info.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/vm-info.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/vm-info.dita	(revision 99016)
Index: trunk/doc/manual/en_US/dita/topics/windows-guest-file-extraction.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/windows-guest-file-extraction.dita	(revision 99014)
+++ trunk/doc/manual/en_US/dita/topics/windows-guest-file-extraction.dita	(revision 99016)