Index: trunk/doc/manual/en_US/dita/UserManual.ditamap
===================================================================
--- trunk/doc/manual/en_US/dita/UserManual.ditamap	(revision 99081)
+++ trunk/doc/manual/en_US/dita/UserManual.ditamap	(revision 99111)
@@ -49,4 +49,5 @@
       <othermeta name="revision" content="$Rev$"/>
       <othermeta name="rev-date" content="$Date$"/>
+      <othermeta name="ditaval" content="ohc.ditaval"/>
       <!-- The bookpartno matches the part and revision in PDB  -->
          <bookid>
Index: trunk/doc/manual/en_US/dita/htmlhelp.ditaval
===================================================================
--- trunk/doc/manual/en_US/dita/htmlhelp.ditaval	(revision 99111)
+++ trunk/doc/manual/en_US/dita/htmlhelp.ditaval	(revision 99111)
@@ -0,0 +1,5 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<val>
+  <prop action="include" att="platform" val="htmlhelp"/>
+  <prop action="exclude" att="platform" val="ohc"/>
+</val>
Index: trunk/doc/manual/en_US/dita/ohc.ditaval
===================================================================
--- trunk/doc/manual/en_US/dita/ohc.ditaval	(revision 99111)
+++ trunk/doc/manual/en_US/dita/ohc.ditaval	(revision 99111)
@@ -0,0 +1,5 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<val>
+  <prop action="exclude" att="platform" val="htmlhelp"/>
+  <prop action="include" att="platform" val="ohc"/>
+</val>
Index: trunk/doc/manual/en_US/dita/topics/soft-keyb.dita
===================================================================
--- trunk/doc/manual/en_US/dita/topics/soft-keyb.dita	(revision 99081)
+++ trunk/doc/manual/en_US/dita/topics/soft-keyb.dita	(revision 99111)
@@ -2,33 +2,39 @@
 <!DOCTYPE topic
   PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
+
 <topic xml:lang="en-us" id="soft-keyb">
-            <title>Soft Keyboard</title>
-            
-            <body>
-               <p>
+  <title>Soft Keyboard</title>
+
+
+  <body>
+    <p>
       Oracle VM VirtualBox provides a <i>soft keyboard</i> that
       enables you to input keyboard characters on the guest. A soft
       keyboard is an on-screen keyboard that can be used as an
       alternative to a physical keyboard. See
-      <xref href="soft-keyb-using.dita#soft-keyb-using"/> for details of how to use the
+      <xref href="soft-keyb-using.dita#soft-keyb-using"/>
+ for details of how to use the
       soft keyboard.
     </p>
-               <note type="caution">
-                  <p>
+    <note type="caution">
+      <p>
         For best results, ensure that the keyboard layout configured on
         the guest OS matches the keyboard layout used by the soft
         keyboard. Oracle VM VirtualBox does not do this automatically.
       </p>
-               </note>
-               <fig id="fig-soft-keyb">
-                  <title>Soft Keyboard in a Guest Virtual Machine</title>
-                  <image href="images/softkeybd.png" width="14cm" placement="break"/>
-               </fig>
-               <p>
+    </note>
+    <fig id="fig-soft-keyb">
+      <title>Soft Keyboard in a Guest Virtual Machine</title>
+      <xref href="images/softkeybd.png" format="png" platform="htmhelp">
+        <image href="images/softkeybd.png" width="14cm" placement="break" id="image_u5k_f4r_wwb"/>
+      </xref>
+      <image platform="ohc" href="images/softkeybd.png" width="14cm" placement="break" id="image_u5k_f4r_wwb"/>
+    </fig>
+    <p>
       The soft keyboard can be used in the following scenarios:
     </p>
-               <ul>
-                  <li>
-                     <p>
+    <ul>
+      <li>
+        <p>
           When the physical keyboard on the host is not the same as the
           keyboard layout configured on the guest. For example, if the
@@ -36,7 +42,7 @@
           host keyboard is US English.
         </p>
-                  </li>
-                  <li>
-                     <p>
+      </li>
+      <li>
+        <p>
           To send special key combinations to the guest. Note that some
           common key combinations are also available in the
@@ -45,25 +51,25 @@
           window. See <xref href="specialcharacters.dita#specialcharacters"/>.
         </p>
-                  </li>
-                  <li>
-                     <p>
+      </li>
+      <li>
+        <p>
           For guests in kiosk mode, where a physical keyboard is not
           present.
         </p>
-                  </li>
-                  <li>
-                     <p>
+      </li>
+      <li>
+        <p>
           When using nested virtualization, the soft keyboard provides a
           method of sending key presses to a guest.
         </p>
-                  </li>
-               </ul>
-               <p>
+      </li>
+    </ul>
+    <p>
       By default, the soft keyboard includes some common international
       keyboard layouts. You can copy and modify these to meet your own
       requirements. See <xref href="soft-keyb-custom.dita#soft-keyb-custom"/>.
     </p>
-            </body>
-            
-            
-         </topic>
+  </body>
+
+
+</topic>